"use strict";
exports.__esModule = true;
exports.formatText = void 0;
var react_1 = require("react");
var react_native_1 = require("react-native");
var createStyledElement = function (_a) {
    var text = _a.text, style = _a.style, jsxElement = _a.jsxElement, props = _a.props;
    return (<>
    {jsxElement}
    <react_native_1.Text {...props} style={[props.style, style]}>
      {text}
    </react_native_1.Text>
  </>);
};
var formatText = function (props, regex) {
    var children = props.children, highlightedTextStyles = props.highlightedTextStyles;
    var TEXT_WITH_BRACKETS = regex.TEXT_WITH_BRACKETS, TEXT_AMONG_BRACKETS = regex.TEXT_AMONG_BRACKETS, KEY_VALUE_TEXT = regex.KEY_VALUE_TEXT, KEY_VALUE_NUMBER = regex.KEY_VALUE_NUMBER;
    var currentStyleIndex = 0;
    var allText = Array.isArray(children) ? children.join() : children;
    var textArray = allText.split(TEXT_WITH_BRACKETS);
    var finalTextElement = textArray.reduce(function (jsxElement, text) {
        if (TEXT_WITH_BRACKETS.test(text)) {
            var pureText = text.replace(TEXT_AMONG_BRACKETS, '$1');
            if (Array.isArray(highlightedTextStyles)) {
                var keyAndText_1 = KEY_VALUE_NUMBER.test(pureText)
                    ? pureText.split('=')
                    : undefined;
                var keys_1 = keyAndText_1 &&
                    keyAndText_1[0]
                        .split(',')
                        .map(function (stringNumbers) { return parseInt(stringNumbers) - 1; });
                if (keyAndText_1 && keys_1) {
                    var styles = keys_1.map(function (key) { return highlightedTextStyles[key]; });
                    var finalText = keyAndText_1[1];
                    currentStyleIndex += 1;
                    return createStyledElement({
                        text: finalText,
                        jsxElement: jsxElement,
                        style: styles,
                        props: props
                    });
                }
                var style = highlightedTextStyles[currentStyleIndex];
                currentStyleIndex += 1;
                return createStyledElement({ text: pureText, jsxElement: jsxElement, style: style, props: props });
            }
            var keyAndText = KEY_VALUE_TEXT.test(pureText)
                ? pureText.split('=')
                : undefined;
            var keys = keyAndText && keyAndText[0].split(',');
            if (keyAndText && keys) {
                var styles = keys.map(function (key) { return highlightedTextStyles[key]; });
                var finalText = keyAndText[1];
                return createStyledElement({
                    text: finalText,
                    jsxElement: jsxElement,
                    style: styles,
                    props: props
                });
            }
            return createStyledElement({ text: pureText, jsxElement: jsxElement, props: props });
        }
        return (<>
        {jsxElement}
        {text}
      </>);
    }, <></>);
    return finalTextElement;
};
exports.formatText = formatText;
