import React from 'react';
import type { Text, TextStyle } from 'react-native';
import type { Regex } from './interfaces';
export declare type HighlightedTextStyles = TextStyle[] | {
    [key: string]: TextStyle;
};
export declare type HighlightedTextProps = React.ComponentProps<typeof Text> & {
    children: string | string[];
    highlightedTextStyles: HighlightedTextStyles;
    characters?: Characters;
};
export declare type CreateStyledElement = (args: {
    text: string;
    jsxElement: JSX.Element;
    style?: TextStyle | TextStyle[];
    props: HighlightedTextProps;
}) => JSX.Element;
export declare type FormatText = (props: HighlightedTextProps, regex: Regex) => JSX.Element;
export declare type Characters = 'square-brackets' | 'curly-brackets' | 'tags' | 'parenthesis';
export declare type GenerateRegex = (characters: Characters) => Regex;
